package org.cakelab.eval.mlatency;

import java.io.PrintStream;

import org.cakelab.eval.model.Measure;
import org.cakelab.eval.run.ResultsLogFile;

public class GNUPlotErrorBar extends GNUPlot {

	class MeasurePlotErrorBars extends MeasurePlot {
		int ylowcol;
		int yhighcol;

		MeasurePlotErrorBars(Measure measure, int xcolumn, int ycolumn, int ylowcol, int yhighcol) {
			super(measure, xcolumn, ycolumn);
			this.ylowcol = ylowcol;
			this.yhighcol = yhighcol;
		}
	}
	
	public GNUPlotErrorBar(String baseDir, String targetFilename, String xtitle, String ytitle, String units) {
		super(baseDir, targetFilename, xtitle, ytitle, units);
	}

	
	
	protected void appendPlotCmd(PrintStream out, MeasurePlot _mp) {
		if (_mp instanceof MeasurePlotErrorBars) {
			MeasurePlotErrorBars mp = (MeasurePlotErrorBars) _mp;
			ResultsLogFile log = (ResultsLogFile) mp.measure.getResultLog();
			String logfile = log.getFileName(mp.measure);
			logfile = logfile.replace(basedir, "..");
	
			out.print("'" + logfile + "' using " + mp.xcolumn + ":" + mp.ycolumn + " title \"" + mp.measure.getName() + "\" with lines, '" + logfile + "' using " + mp.xcolumn + ":" + mp.ycolumn + ":" + mp.ylowcol + ":" + mp.yhighcol + " notitle with errorbars");
		} else {
			super.appendPlotCmd(out, _mp);
		}
	}


	@Override
	public void addMeasureErrorBars(Measure measure, int xcolumn, int ycolumn, int ylowcol, int yhighcol) {
		plots.add(new MeasurePlotErrorBars(measure, xcolumn, ycolumn, ylowcol, yhighcol));
	}


	
}
