package org.cakelab.eval.mlatency;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import org.cakelab.eval.model.MeasurementRun;
import org.cakelab.eval.model.DoubleValueExtractor;
import org.cakelab.statistics.StatisticsDouble;
import org.cakelab.utils.DoubleArray;

public class MLatencyFilteredMeanExtractor implements DoubleValueExtractor {

	private String filter;
	DoubleArray tmp = new DoubleArray(0);

	public MLatencyFilteredMeanExtractor(String filterExpr) {
		filter = filterExpr;
	}

	@Override
	public double getValue(MeasurementRun _run) throws IOException {
		MLatencyMeasurementRun run = (MLatencyMeasurementRun)_run;
		BufferedReader reader = new BufferedReader(new InputStreamReader(run.getStdout()));
	    String line;
	    tmp.clear();
		while ((line = reader.readLine()) != null) {
			if (line.contains(filter)) {
				String[] columns = line.split("\\s+");
				double val = Double.parseDouble(columns[MLatencyMeasurementRun.COLUMN_LATENCY]);
				tmp.add(val);
			}
		}
		reader.close();
		return StatisticsDouble.mean(tmp);
	}
}
