package org.cakelab.eval.mlatency;

import java.io.IOException;

import org.cakelab.eval.model.LaunchConfig;
import org.cakelab.eval.model.MeasurementRun;
import org.cakelab.utils.Arguments;

public class MLatencyLaunchConfig extends LaunchConfig {

	public MLatencyLaunchConfig(String executable, String[] arguments) {
		super(executable, arguments, null);
	}

	@Override
	public MeasurementRun execute() throws IOException, InterruptedException {
		long timestamp = System.currentTimeMillis();
		Process p = super.exec();
		return new MLatencyMeasurementRun(this, timestamp, p.getInputStream(), p.getErrorStream());
	}


	public String getUniqueIdentifier ()
	{
		return executable;
	}

	public void setArgument(String key, String val) {
		Arguments.set(arguments, key, val);
	}

	public void setArgument(String key, int val) {
		Arguments.set(arguments, key, val);
	}

	




}
