package org.cakelab.eval.mlatency;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

import org.cakelab.eval.model.LaunchConfig;
import org.cakelab.eval.model.MeasurementRun;
import org.cakelab.utils.FileSystem;


public class MLatencyMeasurementRun extends MeasurementRun {

	public static final int COLUMN_NO = 0;
	public static final int COLUMN_TASK_NAME = 1;
	public static final int COLUMN_LATENCY = 2;

	
	private String stdoutFilename;
	private String stderrFilename;
	private InputStream stdoutStream;
	private InputStream stderrStream;
	
	public MLatencyMeasurementRun(LaunchConfig launch, long timestamp, InputStream stdout, InputStream stderr) throws IOException {
		super(launch, timestamp);
		this.stdoutStream = stdout;
		this.stderrStream = stderr;
	}
	private MLatencyMeasurementRun(LaunchConfig launch, long timestamp) {
		super(launch, timestamp);
		
	}
	

	public InputStream getStdout() throws IOException {
		return new FileInputStream(stdoutFilename);
	}

	public InputStream getStderr() throws IOException {
		return new FileInputStream(stderrFilename);
	}



	
	//////////////////////////////////////////////////////////////
	// INTERNAL FUNCTIONS FOR DATA EXCHANGE WITH DATA STORE
	//////////////////////////////////////////////////////////////
	
	
	InputStream getStdoutStream() {
		return stdoutStream;
	}

	InputStream getStderrStream() {
		return stderrStream;
	}

	void setStdoutFilename(String stdoutFilename) {
		this.stdoutFilename = stdoutFilename;
	}

	void setStderrFilename(String stderrFilename) {
		this.stderrFilename = stderrFilename;
	}

	public static MeasurementRun load(LaunchConfig launch, File file, String stdoutFilename, String stderrFilename) {
		MLatencyMeasurementRun run = null;
		if (file.exists()) {
			run = new MLatencyMeasurementRun(launch, FileSystem.runDirTimeStamp(file));
			run.setStdoutFilename(stdoutFilename);
			run.setStderrFilename(stderrFilename);
		}
		return run;
	}
	
	
}
