package org.cakelab.eval.mlatency;

import java.io.FileNotFoundException;
import java.io.IOException;

import org.cakelab.eval.model.LaunchConfig;
import org.cakelab.eval.model.Measure;
import org.cakelab.eval.run.ResultsLogFile;
import org.cakelab.utils.Text;

public class MLatencyResultsLogThreads extends ResultsLogFile {

	public MLatencyResultsLogThreads(String targetDir) throws FileNotFoundException {
		super(targetDir);
	}
	
	@Override
	public void store(Measure measure, long timestamp, LaunchConfig launch) throws IOException {
		StringBuffer valuesStr = new StringBuffer();
		Number[] values = measure.getValues();
		for (Number val : values) {
			valuesStr.append(val);
			valuesStr.append(Text.columnSeparator);
		}
		double err = measure.getError();
		
		double mean = (Double) values[1];
		valuesStr.append(mean - err);
		valuesStr.append(Text.columnSeparator);
		
		valuesStr.append(mean + err);
		valuesStr.append(Text.columnSeparator);
		
		long threads = launch.getArgumentLong("-w", 0) + launch.getArgumentLong("-r", 0);
		out.println(threads + Text.columnSeparator + valuesStr.toString());
	}


}
