package org.cakelab.eval.model;

import java.io.IOException;

/**
 * Data log receives log entries with all raw information generated 
 * by measurement runs of a particular launch configuration.
 * The log is associated with:
 * <ul>
 * <li>LaunchConfig: The launch configuration the run was executed with</li>
 * </ul>
 * An entry of the log exists of:
 * <ul>
 * <li>Number: The number of the measurement run </li>
 * <li>Run start time: The time the run was executed </li>
 * <li>Data: All raw data received from the particular run</li>
 * </ul>
 * @author homac
 *
 */
public interface DataLog extends Iterable<MeasurementRun> {

	void open(LaunchConfig launch) throws IOException;

	void store(MeasurementRun run) throws IOException;

	void close() throws IOException;

}
