package org.cakelab.eval.model;


/**
 * A measurement run object provides access to all data related 
 * to a particular measurement run.
 * 
 * A measurement run is just a reflection of raw data which is stored 
 * anywhere (e.g. filesystem). Thus, a measurement run is expected
 * to be stored before it is considered in the calculation of measures.
 * 
 * @author homac
 *
 */
public abstract class MeasurementRun {
	private LaunchConfig config;
	private long timestamp;

	
	
	public MeasurementRun(LaunchConfig config, long timestamp) {
		this.config = config;
		this.timestamp = timestamp;
	}
	
	/**
	 * @return the config
	 */
	public LaunchConfig getLaunchConfig() {
		return config;
	}

	public long getTimestamp() {
		return timestamp;
	}

}
