package org.cakelab.eval.run;

import org.cakelab.statistics.Statistics;

public class AbsoluteAccuracy extends EstimatedMeanError {

	private int significantDigits;

	public AbsoluteAccuracy(int minSamples, int significantDigits) {
		super(minSamples);
		this.significantDigits = significantDigits;
	}
	
	@Override
	public boolean isConfident(Statistics stats) {
		if (stats.getNum() < minSamples) return false;
		
		double maxAllowedDev = Math.pow(10, Math.log10(stats.getMean()) - significantDigits);
		double maxDeviation = getError(stats);
		Report.info("expected next deviation: " + maxDeviation);
		return maxDeviation <= maxAllowedDev;
	}


}
