package org.cakelab.eval.run;

import org.cakelab.statistics.Statistics;

public class AbsoluteDeviation extends EstimatedMeanError {

	private double maxAbsoluteDeviation;

	public AbsoluteDeviation(int minSamples, double maxAbsoluteDeviation) {
		super(minSamples);
		this.maxAbsoluteDeviation = maxAbsoluteDeviation;
	}
	
	@Override
	public boolean isConfident(Statistics stats) {
		if (stats.getNum() < minSamples) return false;
		
		double maxDeviation = getError(stats);
		Report.info("expected next deviation: " + maxDeviation);
		return maxDeviation <= this.maxAbsoluteDeviation;
	}

}
