package org.cakelab.eval.run;

import org.cakelab.statistics.Statistics;

public class RelativeAccuracy extends EstimatedMeanError {

	private double maxDeviationRatio;
	private int minSamples;

	public RelativeAccuracy(int minSamples, double maxDeviationToRangeRatio) {
		super(minSamples);
		this.maxDeviationRatio = maxDeviationToRangeRatio;
	}
	
	@Override
	public boolean isConfident(Statistics stats) {
		if (stats.getNum() < minSamples) return false;
		
		double maxDeviation = getError(stats);
		
		/* now standardise against full range of samples and compare to requested maximum deviation ratio */
		double relativeMaxMeanDeviation = maxDeviation/stats.getStddev();
		Report.info("current relative max mean deviation: " + relativeMaxMeanDeviation);

		return relativeMaxMeanDeviation <= maxDeviationRatio;
	}

}
