package org.cakelab.utils;

import java.util.Arrays;

public class DoubleArray {
	public double a[];
	private int capacity;
	private int size;
	
	public DoubleArray(int initial_capacity) {
		capacity = initial_capacity > 0 ? initial_capacity : 1;
		a = new double[capacity];
		size = 0;
	}
	
	
	public void add(double val) {
		if (size == capacity) resize(capacity*2);
		a[size] = val;
		size++;
	}


	private void resize(int new_cap) {
		double[] tmp = new double[new_cap];
		System.arraycopy(a, 0, tmp, 0, size);
		a = tmp;
		capacity = new_cap;
	}


	public int size() {
		return size;
	}
	
	public void sort() {
		Arrays.sort(a, 0, size);
	}


	public void clear() {
		size = 0;
	}

}
