package org.cakelab.utils;

import java.util.Arrays;

public class LongArray {
	public long a[];
	private int capacity;
	private int size;
	
	public LongArray(int initial_capacity) {
		capacity = initial_capacity > 0 ? initial_capacity : 1;
		a = new long[capacity];
		size = 0;
	}
	
	
	public void add(long val) {
		if (size == capacity) resize(capacity*2);
		a[size] = val;
		size++;
	}


	private void resize(int new_cap) {
		long[] tmp = new long[new_cap];
		System.arraycopy(a, 0, tmp, 0, size);
		a = tmp;
		capacity = new_cap;
	}


	public long size() {
		return size;
	}
	
	public void sort() {
		Arrays.sort(a, 0, size);
	}


	public void clear() {
		size = 0;
	}
}
